﻿#target illustrator
mm = 2.83464567; 
main();

function main()
{
var values = myInput ();
var doc = app.documents.add(DocumentColorSpace.CMYK,  values.horizont*mm,  values.vertical*mm,  1,  DocumentArtboardLayout.Row,  500); 
roundD = values.luvers;
offset = 25 - roundD/2;
cmykC = values.C;
cmykM = values.M;
cmykY = values.Y;
cmykK = values.K;
addCircle (offset+roundD, offset); //лево-низ
addCircle (offset+roundD, values.horizont-offset-roundD); // право низ
addCircle (values.vertical-offset, offset); // лево верх
addCircle (values.vertical-offset, values.horizont-offset-roundD); // право верх
var countHorisont = Math.round((values.horizont-40)/values.circleBetweenHorizont);
var countVertical = Math.round((values.vertical-40)/values.circleBetweenVertical);
var stepHorisont = ((+values.horizont-50)/countHorisont);
var stepVertical = ((+values.vertical-50)/countVertical);

 
var pos =offset; while (pos < (+values.horizont-(offset*2))-stepHorisont)   { 
        pos = +pos + stepHorisont;
        addCircle (offset+roundD, pos); //низ
   } 
pos =offset; while (pos < (+values.horizont-offset*2)-stepHorisont)    {
        pos = +pos + stepHorisont;
        addCircle (values.vertical-offset,pos); //верх!
    }
pos =offset+roundD; while (pos < (+values.vertical-offset*2)-stepVertical)     {
        pos = +pos + stepVertical;
        addCircle (pos,values.horizont-offset-roundD);  // право!
    }
pos =offset+roundD; while (pos < (+values.vertical-offset*2)-stepVertical)     {
        pos = +pos + stepVertical;
        addCircle (pos,offset); // лево!
    }
var a = [];
a.push('По горизонтали: ' + (+countHorisont+1));
a.push('По вертикали: ' + (+countVertical+1));
alert(a.join('\n'));
return 0;
}

function myInput (){
var myWindow = new Window ("dialog", "Расстановка люверсов"); myWindow.add ("statictext", undefined, "Введите размер страницы (в мм): ");

var myInputGroup = myWindow.add ("group"); myInputGroup.add ("statictext", undefined, "По горизонтали: ");
var myPageGor = myInputGroup.add ("edittext", undefined, "1500"); myPageGor.characters = 5; 
myPageGor.active = true; myInputGroup.add ("statictext", undefined, "По вертикали: ");
var myPageVert = myInputGroup.add ("edittext", undefined, "1500"); myPageVert.characters = 5; 
myWindow.add ("statictext", undefined, "Расстояние между люверсами (в мм): ");

var myInputGroup2 = myWindow.add ("group"); myInputGroup2.add ("statictext", undefined, "По горизонтали:");
var myTextGor = myInputGroup2.add ("edittext", undefined, "500"); myTextGor.characters = 5; 
myInputGroup2.add ("statictext", undefined, "По вертикали: ");
var myTextVert = myInputGroup2.add ("edittext", undefined, "500"); myTextVert.characters = 5; 

var myInputGroup3 = myWindow.add ("group"); myInputGroup3.add ("statictext", undefined, "Люверсы размер в мм:");
var myLuvers = myInputGroup3.add ("edittext", undefined, "8"); myLuvers.characters = 5; 

var myInputGroup4 = myWindow.add ("group"); myInputGroup4.add ("statictext", undefined, "CMYK:");
var myC = myInputGroup4.add ("edittext", undefined, "66"); myC.characters = 5; 
var myM = myInputGroup4.add ("edittext", undefined, "0"); myM.characters = 5; 
var myY = myInputGroup4.add ("edittext", undefined, "100"); myY.characters = 5; 
var myK = myInputGroup4.add ("edittext", undefined, "0"); myK.characters = 5; 


var myButtonGroup = myWindow.add ("group"); myButtonGroup.add ("button", undefined, "OK");
myButtonGroup.add ("button", undefined, "Cancel");

if (myWindow.show () == 1)
return {horizont : Number(myPageGor.text) , vertical: Number(myPageVert.text), circleBetweenHorizont : Number(myTextGor.text), circleBetweenVertical : Number(myTextVert.text), luvers : Number(myLuvers.text),
    C:Number(myC.text), M:Number(myM.text), Y:Number(myY.text), K:Number(myK.text)};
else exit();
}



function addCircle (top,left) {
var myDoc = app.activeDocument;  
try {artLayer = myDoc.layers.getByName("Circles"); } // проверяем, есть ли уже в документе "Spot 1"
catch (e) { // если нет (появляется ошибка), то добавляем его, а если уже есть - то пропускаем блок ниже
                var layerDraw = myDoc.layers.add(); //добавляем новый слой
                layerDraw.name = "Circles";
                var artLayer = layerDraw;
                }
var addEllipse = artLayer.pathItems.ellipse(top*mm, left*mm, roundD*mm, roundD*mm, false, true ); //([top][,left][,width][,height][,reversed][,inscribed])
addEllipse.filled = true; 
addEllipse.fillColor = makeColor(cmykC,cmykM,cmykY,cmykK); 
//addEllipse.stroked  = true; 
//addEllipse.strokeColor = makeColor(30,90,0,0); 
}

function makeColor(c,m,y,k){
    var ink = new CMYKColor();
    ink.cyan   = c;
    ink.magenta = m;
    ink.yellow  = y;
    ink.black  = k;
    return ink;
}